clc; clear all; close all;

%% PUNTO 1: Schema senza disturbo (verifica limite di stabilità k=8)

% Apri ese_controllo_serbatoi_senza_disturbo.mdl

k = 4;      % --> asintoticam. stabile
sim('ese_controllo_serbatoi_senza_disturbo.mdl',50)

k = 8;      % --> semplicem. stabile
sim('ese_controllo_serbatoi_senza_disturbo.mdl',50)

k = 10;     % --> instabile, diverge
sim('ese_controllo_serbatoi_senza_disturbo.mdl',50)

%% PUNTO 2: Aggiunta del disturbo - andamento dell'uscita

vett_k = [0 0.3 0.6 1 2 3 4 5 6 7];
uscita = zeros(length(vett_k),1);

for i = 1:length(vett_k)
    k = vett_k(i);
    sim('ese_controllo_serbatoi_disturbo.mdl',100)
    uscita(i) = y(end);
end 

figure
plot(vett_k,uscita,'b*')
hold on

k = [0:0.1:8];
yeq = 5 + 1./(k+1);

plot(k,yeq,'r')
xlabel('k'); ylabel('uscita')

%% PUNTO 3: Aggiunta del disturbo - valutazione tempo di risposta

vet_k=[]; vet_TR=[];

for k = 0:0.1:7.5
    A = [-1 0 -k;
          1 -1 0;
          0 1 -1];
    reale_lD=max(real(eig(A)));
    TR=-5/reale_lD;
    
    vet_k=[vet_k;k];
    vet_TR=[vet_TR;TR];
end

figure
plot(vet_k,vet_TR)
xlabel('k'); ylabel('Tempo di risposta');

